C===================================================================
C
      PROGRAM RECT4
C
C  This program creates the INPUTFILE for ELBECON when the 
C  domain is a rectangle AA*BB
C
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*15 INPUTFILE 
      CHARACTER*80 NAME,TITLE
      PARAMETER (N=44)
      PARAMETER (IN=3)
      PARAMETER (NB=1)
      DIMENSION XL(N+1),YL(N+1),XIN(IN),YIN(IN)
      DIMENSION KCODE(N),UB(N),VB(N),NL(NB)
C      
      WRITE (*,'(A)')' Name of the INPUTFILE (max.15 characters)'
      READ  (*,'(A)') INPUTFILE
      OPEN (1, FILE=INPUTFILE)
      WRITE (*,'(A)')' User NAME (max.15 characters)'
      READ(*,'(A)')NAME
      WRITE(1,'(A)')NAME
      WRITE (*,'(A)')' Program TITLE (max.15 characters)' 
      READ(*,'(A)')TITLE
      WRITE(1,'(A)')TITLE
      WRITE(1,100)
  100 FORMAT(' ',79(' '))
C
      IPLANE=1
      WRITE(1,150)IPLANE
  150 FORMAT(I4)
      EL=200000.
      PN=.2
      WRITE(1,200)EL,PN
  200 FORMAT(F10.0,F6.3)        
      WRITE(1,100)
C
      NL(1)=N
      WRITE(1,250)(NL(I),I=1,NB)
  250 FORMAT(I4)
C
C  Boundary coordinates  
C    
      AA=3.
      BB=1.
      NX=15
      NY=7
      DA=AA/NX
      DB=BB/NY
      DO 1 I=1,NX      
      XL(I)=(I-1)*DA
      YL(I)=0.      
    1 WRITE(1,300)XL(I),YL(I)
  300 FORMAT(2(F14.8,2X))
C     
      DO 2 I=1,NY      
      XL(I+NX)=AA
      YL(I+NX)=(I-1)*DB
    2 WRITE(1,300)XL(I+NX),YL(I+NX)
C    
      DO 3 I=1,NX      
      XL(I+NX+NY)=AA-(I-1)*DA
      YL(I+NX+NY)=BB      
    3 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 4 I=1,NY      
      XL(I+NX+NY+NX)=0.
      YL(I+NX+NY+NX)=BB-(I-1)*DB
    4 WRITE(1,300)XL(I+NX+NY+NX),YL(I+NX+NY+NX)
      WRITE(1,100)
C   
C  Boundary conditions  
C
      XL(N+1)=XL(1)
      YL(N+1)=YL(1)
      DO 10 I=1,NX
      KCODE(I)=2
      XM=(XL(I)+XL(I+1))/2. 
      YM=(YL(I)+YL(I+1))/2.
      UB(I)=0.  
   10 VB(I)=0.
      DO 20 I=1,NY
      II=I+NX
      KCODE(II)=1
      XM=(XL(II)+XL(II+1))/2. 
      YM=(YL(II)+YL(II+1))/2.
      UB(II)=0.  
   20 VB(II)=0.
      DO 30 I=1,NX
      II=I+NX+NY
      KCODE(II)=2
      XM=(XL(II)+XL(II+1))/2. 
      YM=(YL(II)+YL(II+1))/2.
      UB(II)=0.  
   30 VB(II)=-1.
      DO 40 I=1,NY
      II=I+NX+NY+NX
      KCODE(II)=1
      XM=(XL(II)+XL(II+1))/2. 
      YM=(YL(II)+YL(II+1))/2.
      UB(II)=0. 
   40 VB(II)=0.
      DO 50 I=1,N
   50 WRITE(1,400)KCODE(I),UB(I),VB(I)
  400 FORMAT(I4,3X,2(F18.8))
C      
      WRITE(1,100)
C
C  Coordinates of the internal points
C
      IX=1
      JY=3
      DX=AA/IX
      DY=BB/(JY+1)
      WRITE(1,100)     
C
      DO 5 J=1,JY 
      DO 5 I=1,IX       
      K=(J-1)*JY+I
      XIN(K)=DX/2.+(I-1)*DX
      YIN(K)=DY+(J-1)*DY
      WRITE(1,300)XIN(K),YIN(K)
    5 CONTINUE    
C      
      WRITE(1,100)
C    
      STOP
      END
C
C===================================================================
     