C===================================================================
C
      PROGRAM RECTELMU
C
C
C  This program creates the INPUTFILE for ELBECON when the 
C  domain is multiply connected (rectangular boundaries)
C    
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*15 INPUTFILE 
      CHARACTER*80 NAME,TITLE
      PARAMETER (N=348)
      PARAMETER (IN=284)
	PARAMETER (NB=2)
      DIMENSION XL(N+1),YL(N+1),XIN(IN),YIN(IN),XM(N),YM(N)
      DIMENSION KCODE(N),UB(N),VB(N),NL(NB)
C      
      WRITE (*,'(A)')' Name of the INPUTFILE (max.15 characters)'
      READ  (*,'(A)') INPUTFILE
      OPEN (1, FILE=INPUTFILE)
      WRITE (*,'(A)')' User NAME (max.15 characters)'
      READ(*,'(A)')NAME
      WRITE(1,'(A)')NAME
      WRITE (*,'(A)')' Program TITLE (max.15 characters)' 
      READ(*,'(A)')TITLE
      WRITE(1,'(A)')TITLE
C      
      WRITE(1,100)
  100 FORMAT(' ',79(' '))
C
	IPLANE=0
	WRITE(1,150)IPLANE
  150	FORMAT(I4)
	EL=200000.
	PN=.2
      WRITE(1,200)EL,PN
  200 FORMAT(F10.0,F6.3)        
C      
      WRITE(1,100)
C
  	NL(1)=284
	NL(2)=348
	WRITE(1,250)(NL(I),I=1,NB)
  250	FORMAT(I4)
C
C  Boundary coordinates  
C
	DO 111 K=1,NB

	IF (K.EQ.1) THEN
      AA=2.5
      BB=1.5
      NX=91
      NY=51

      DA=AA/NX
      DB=BB/NY
      DO 1 I=1,NX      
      XL(I)=(I-1)*DA
      YL(I)=0.      
    1 WRITE(1,300)XL(I),YL(I)
  300 FORMAT(2(2X,F14.8))
C     
      DO 2 I=1,NY      
      XL(I+NX)=AA
      YL(I+NX)=(I-1)*DB
    2 WRITE(1,300)XL(I+NX),YL(I+NX)
C    
      DO 3 I=1,NX      
      XL(I+NX+NY)=AA-(I-1)*DA
      YL(I+NX+NY)=BB      
    3 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 4 I=1,NY      
      XL(I+NX+NY+NX)=0.
      YL(I+NX+NY+NX)=BB-(I-1)*DB
    4 WRITE(1,300)XL(I+NX+NY+NX),YL(I+NX+NY+NX)

	ELSE

	AA=1.0
	BB=0.5
	NX=21
	NY=11
      DA=AA/NX
      DB=BB/NY
      DO 6 J=1,NY
	I=J+NL(1)      
	XL(I)=0.75
	YL(I)=0.5+(J-1)*DB
    6 WRITE(1,300)XL(I),YL(I)
C     
      DO 7 J=1,NX
	I=J+NL(1)      
	XL(I+NY)=0.75+(J-1)*DA
	YL(I+NY)=BB+0.5
    7 WRITE(1,300) XL(I+NY),YL(I+NY)
C    
      DO 8 J=1,NY      
	I=J+NL(1)      
	XL(I+NX+NY)=0.75+AA
	YL(I+NX+NY)=0.5+BB-(J-1)*DB
    8 WRITE(1,300)XL(I+NX+NY),YL(I+NX+NY) 
C    
      DO 9 J=1,NX
	I=J+NL(1)      
      XL(I+NY+NX+NY)=0.75+AA-(J-1)*DA
      YL(I+NY+NX+NY)=0.5
    9 WRITE(1,300)XL(I+NY+NX+NY),YL(I+NY+NX+NY)
	ENDIF
C      
  111	CONTINUE

	WRITE (1,100)
C
C Boundary conditions  
C
	DO 112 K=1,NB
	IF (K.EQ.1) THEN
      NX=91
      NY=51
	NF=1 

      XL(NL(1)+1)=XL(NF)
      YL(NL(1)+1)=YL(NF)

      DO 10 I=1,NX
      KCODE(I)=4
      XM(I)=(XL(I)+XL(I+1))/2. 
      YM(I)=(YL(I)+YL(I+1))/2.
      UB(I)=0.0  
   10 VB(I)=0.0
      DO 20 I=1,NY
	II=I+NX
      KCODE(II)=3
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=0.0
   20 VB(II)=0.0
      DO 30 I=1,NX
	II=I+NX+NY
      KCODE(II)=2
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=0.0  
   30 VB(II)=0.0
      DO 40 I=1,NY
	II=I+NX+NY+NX
      KCODE(II)=3
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=0.  
   40 VB(II)=0.

	ELSE
	NX=21
	NY=11
	NF=NL(1)+1

      XL(NL(2)+1)=XL(NF)
      YL(NL(2)+1)=YL(NF)

      DO 11 J=1,NY
	I=J+NL(1)
      KCODE(I)=2
      XM(I)=(XL(I)+XL(I+1))/2. 
      YM(I)=(YL(I)+YL(I+1))/2.
      UB(I)=-1000.
   11 VB(I)=0.
      DO 21 J=1,NX
	I=J+NL(1)
	II=I+NY
      KCODE(II)=2
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=0.0
   21 VB(II)=1000.
      DO 31 J=1,NY
	I=J+NL(1)
	II=I+NX+NY
      KCODE(II)=2
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=1000.  
   31 VB(II)=0.
      DO 41 J=1,NX
	I=J+NL(1)
	II=I+NX+NY+NY
      KCODE(II)=2
      XM(II)=(XL(II)+XL(II+1))/2. 
      YM(II)=(YL(II)+YL(II+1))/2.
      UB(II)=0.  
   41 VB(II)=-1000.
	ENDIF
  112	CONTINUE
C
      DO 50 I=1,N
   50 WRITE(1,400) KCODE(I),UB(I),VB(I)
  400 FORMAT(I4,3X,2(F20.8))

C      
      WRITE(1,100)
C
C     Coordinates of the internal points
C
      IX=25
      JY=15
	AA=2.5
	BB=1.5
      DX=AA/IX
      DY=BB/JY
      WRITE(1,100)     
C
	ICOUNT=0
      DO 5 J=1,JY-1       
      DO 5 I=1,IX 
      XTEMP = DX/2.+FLOAT(I-1)*DX
	YTEMP = DY+FLOAT(J-1)*DY
	Q1=XTEMP-0.75 
     	Q2=XTEMP-1.75
	Q3=YTEMP-0.50
     	Q4=YTEMP-1.00
      IF (Q1.GE.-1.E-5 .AND. Q2.LE.1.E-5  .AND.
	1    Q3.GE.-1.E-5 .AND. Q4.LE.1.E-5) GOTO 5						   
	ICOUNT=ICOUNT+1 
	XIN(ICOUNT) = XTEMP
	YIN(ICOUNT) = YTEMP
      WRITE (1,300) XTEMP, YTEMP
    5 CONTINUE
      WRITE (1,*) ICOUNT  
C      
      WRITE(1,100)
C    
      STOP
      END 
C
C===================================================================       